# @axway/api-builder-plugin-fn-javascript

## About

This plugin installs the JavaScript flow-node to be used within [Axway API Builder's](https://www.axway.com/en/datasheet/axway-api-builder)
flow editor.

## Usage

Check our docs on [How to use the JavaScript plugin](https://docs.axway.com/bundle/API_Builder_4x_allOS_en/page/javascript_flow-node.html).

## Methods

### Exectute

Allows the execution of JavaScript code and returns the result of the execution as the flow-node's output.

| Param | Type | Description | Configuration selection | Required |
| --- | --- | --- | --- | --- |
| code | string | A JavaScript function body. Supports `await` and returning promises. | Selector, String | Yes |
| data | any | The value to apply as the `data` argument to the JavaScript code. For objects and arrays, `data` is passed by reference. | Any | No |
| Unsafe Mode | boolean | USE WITH CAUTION. When enabled, JavaScript is not executed in a sandboxed environment and all globals are available. | Selector, Boolean | No |

## Install

After creating your API Builder service (`api-builder init`), you can install this plugin using npm:

```
npm install --no-optional @axway/api-builder-plugin-fn-javascript
```

The "JavaScript" flow-node will then be available in the tools panel when creating or editing Flows.

## Changes

#### 1.2.6
- #6414: Migrate from axway-flow-sdk to @axway/api-builder-sdk@1.0.0.

#### 1.2.5
- #6315: Internal chore.

#### 1.2.4
- #6233: Fix issue where errors were resolved as an object instead of resolving with an actual `Error`.

#### 1.2.3
- #6222: Improve security testing for unsafe mode.
- #6222: Remove unexpected `constructor` property mutating `data` and global `console` during unsafe mode.
- #6222: Remove access to external Object contructor on `data` during code execution while ensuring it remains a non-enumerable property during unsafe mode.

#### 1.2.2
- #6153: Updated documentation.

#### 1.2.1
- #6116: Bump `axway-flow-sdk` dependency

#### 1.2.0
- #6093: Removed the explicit maximum supported Node.js version limitation in package.json.
- #6093: Internal test suite clean up.

#### 1.1.4
- #6118: Fix `README.md` installation instructions.

#### 1.1.3
- #6026: Document ranges of supported Node.js versions in package.json.

#### 1.1.2
- #6074: Internal CI chore.

#### 1.1.1
- #5924: Bump `axway-flow-sdk` dependency.

#### 1.1.0
- #5829: Update `code` and `Unsafe Mode` parameters to use `initialType` string and boolean respectively to simplify the Flow-Node UX.

#### 1.0.0
- #5891: Update `code` parameter to use the `javascript` format and display a function wrapper using `multilineWrapper` to give context in the UI.

#### 0.1.1
- #5876: Prerelease, initial implementation.

## License

This code is proprietary, closed source software licensed to you by Axway. All Rights Reserved. You may not modify Axway’s code without express written permission of Axway. You are licensed to use and distribute your services developed with the use of this software and dependencies, including distributing reasonable and appropriate portions of the Axway code and dependencies. Except as set forth above, this code MUST not be copied or otherwise redistributed without express written permission of Axway. This module is licensed as part of the Axway Platform and governed under the terms of the Axway license agreement (General Conditions) located here: [https://support.axway.com/en/auth/general-conditions](https://support.axway.com/en/auth/general-conditions); EXCEPT THAT IF YOU RECEIVED A FREE SUBSCRIPTION, LICENSE, OR SUPPORT SUBSCRIPTION FOR THIS CODE, NOTWITHSTANDING THE LANGUAGE OF THE GENERAL CONDITIONS, AXWAY HEREBY DISCLAIMS ALL SUPPORT AND MAINTENANCE OBLIGATIONS, AS WELL AS ALL EXPRESS AND IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO IMPLIED INFRINGEMENT WARRANTIES, WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, AND YOU ACCEPT THE PRODUCT AS-IS AND WITH ALL FAULTS, SOLELY AT YOUR OWN RISK. Your right to use this software is strictly limited to the term (if any) of the license or subscription originally granted to you.
